/*
 File: wysuwyg_dragboard.js
 Copyright: Rahul Singh
 Mail: induscrypt@gmail.com
 Source: http://wysuwyg.mozdev.org
 Referenced by: wysuwyg_dragdrop.xul
 Description: A window with DND capabilities, to be opened in the sidebar
 			Uses a separate 'board' objects for each format	

*/

var os= Components.classes["@mozilla.org/xre/app-info;1"].getService(Components.interfaces.nsIXULRuntime).OS;
var isWin= (/^Win/i).test(os);
 	
 var boardObserver = { 
 		getSupportedFlavours : function () 
 		{
 			var flavours = new FlavourSet();
 			//flavours.appendFlavour("text/html");
 			flavours.appendFlavour("text/x-moz-url");
 			flavours.appendFlavour("text/unicode");	 			
 			return flavours;
 		},
 		
 		onDragOver: function (evt,flavour,session)
 		{ //do nothing
 		},
 		
 		
 		onDrop: function (evt,dropdata,session)
 		{
 			if (dropdata.data!="")
 			{
 		   var dragSession=session;
 		   //alert(dropdata.data + "\n content type= "+ dropdata.flavour.contentType);
 		  
 			var elem=document.createElement("textbox"); 
 			evt.target.appendChild(elem);
 			
 			elem.setAttribute("multiline",true); 			
 			elem.setAttribute("value",dropdata.data);
 			elem.setAttribute("onfocus","select()"); //whoa :-) 			
 			}
 		},
 		
 	
 };
 
 
  var htmlObserver = { 
 		getSupportedFlavours : function () 
 		{
 			var flavours = new FlavourSet(); 	
 			flavours.appendFlavour("text/html"); 			 			
 			return flavours;
 		},
 		
 		onDragOver: function (evt,flavour,session)
 		{ //do nothing
 		},
 		
 		
 		onDrop: function (evt,dropdata,session)
 		{
 			if (dropdata.data!="")
 			{
 		   var dragSession=session;
 		   //alert(dropdata.data + "\n content type= "+ dropdata.flavour.contentType);
 		  
 			var elem=document.createElement("textbox"); 
 			evt.target.appendChild(elem);
 			
 			elem.setAttribute("multiline",true); 			
 			elem.setAttribute("value",dropdata.data);
 			elem.setAttribute("onfocus","select()"); //whoa :-) 			
 			}
 		},
 		
 	
 };
 
 /* **************************************************************** */
 /*Dec-Jan-March:  Changing it so that it creates image stuff from dropped HTML, 
		 as it was still not getting images flavour on Linux. 
 */
 
  var imgDNDObserver = {
  
       
 		getSupportedFlavours : function () 
 		{
 			var flavours = new FlavourSet();
 			if (isWin)
 			{
 				flavours.appendFlavour("image/png"); 			
 				flavours.appendFlavour("image/jpg");flavours.appendFlavour("image/jpeg");
 				flavours.appendFlavour("image/gif");
 			}
 			else
 			flavours.appendFlavour("text/html"); 
 			 			 			
 			return flavours;
 		},
 		
 		onDragOver: function (evt,flavour,session)
 		{
 		},
 		
 		
 		//image DND doesn't work properly on Linux, so two separate OS specific routines
 		onDrop: function (evt,dropdata,session)
 		{  
			try{
			
						
			if (isWin){imgDNDObserver.winOnDrop(evt,dropdata,session); return }

 		   	//Check if the dropped thing is an image:
			var dt=dropdata.data;
			if (dt==null) return;
			if (dt==""){alert(" No Data! ");return;} //Should ever?
			
			var imgtag=dt.match(/<img\s[^>]*>/gi);
			if  (imgtag == null ){return;}/*alert("Data doesn't contain any image!\n" + dt)*/
			//else
			 		   	
 		  
 			//if an image is already present, then that image becomes the target!	
 			var evtTarget=evt.target;
 			var tID=" "+evtTarget.getAttribute("id");
 			//climb up to the box
 			while(tID.search(/imgboard/) == -1 )
 			{
 			  evtTarget=evtTarget.parentNode;
 			  tID=" "+evtTarget.getAttribute("id");
 			
 			} 			
 			var topBox=evtTarget;  		   
 			
 			//parse the tag for attribs
			var tmpvar = null;
			var imgsrc = null;
			var imgstyle = null;
			var imgdomain =null;
			var imgw = null;
			var imgh = null;
			var bW=false; 
			var bH=false; 
			
			tmpvar=imgtag[0].match(/src[\s]*=[\s]*['"][^"']*/gi);
			if (tmpvar) imgsrc=tmpvar[0].replace( /src[\s]*=[\s]*['"]/gi,"");
				if(!imgsrc) return;		
			
			tmpvar=imgtag[0].match(/style[\s]*=[\s]*['"][^"']*/gi);
			if (tmpvar) 
				{imgstyle=tmpvar[0].replace( /style[\s]*=[\s]*['"]/gi,"");
				//see if style provides height/width
				if ( imgstyle.match(/width:[\s]*[\d]/gi) ) bW=true;
				if ( imgstyle.match(/width:[\s]*[\d]/gi) ) bH=true;
				}
			if (!imgw && !bW)
				{
				tmpvar=imgtag[0].match(/width[\s]*=[\s]*['"][^"']*/gi);
				if (tmpvar) imgw=tmpvar[0].replace( /width[\s]*=[\s]*['"]/gi,"");
				}
			if (!imgh && !bH)
				{
				tmpvar=imgtag[0].match(/height[\s]*=[\s]*['"][^"']*/gi);
				if (tmpvar) imgh=tmpvar[0].replace( /height[\s]*=[\s]*['"]/gi,"");
				}
			tmpvar = imgsrc.match(/\/\/[^\/]*/g);
			if (tmpvar) 
				{ 
					imgdomain= (tmpvar[0]).substring(2);
				}
			tmpvar=null;
			
			
			var elem=  document.createElementNS("http://www.w3.org/1999/xhtml","html:img"); //else an XUL image was created
			//(session.sourceNode).cloneNode(true);
 			
 			//needed
 			if (!imgw && !bW )imgw="100"; elem.setAttribute("width",imgw);
 			if (!imgh && !bH)imgh="100"; elem.setAttribute("height",imgh);
			if (imgstyle)elem.setAttribute("style",imgstyle);
			if (imgdomain) elem.setAttribute("alt","Source - "+imgdomain); 	
				
 			elem.setAttribute("src",imgsrc);
 			//delete on doubleclick
 			//elem.setAttribute("ondblclick","imgDNDObserver.deleteThis(event)"); //a gotcha! :-) 			
			topBox.appendChild(elem);		
			
 		 }catch(ex) {alert("Error: " + ex.message); /* or Die silently? */ }
 		},
 		
 		//Image DND for windows.
 		winOnDrop: function (evt,dropdata,session)
 		{
 			var type=dropdata.flavour.contentType;
 		   	if (type.search(/^image/) == -1) {alert("Data doesn't look like an image!");return;}
 		   	
 		   	//else
 		  try{
 			//if an image is already present, then that image becomes the target!	
 			var evtTarget=evt.target;
 			var tID=" "+evtTarget.getAttribute("id");
 			//climb up to the box
 			while(tID.search(/imgboard/) == -1 )
 			{
 			  evtTarget=evtTarget.parentNode;
 			  tID=" "+evtTarget.getAttribute("id");
 			
 			}
 			
 			var topBox=evtTarget; 			
 		   var elem=  document.createElementNS("http://www.w3.org/1999/xhtml","html:img"); //else an XUL image was created
			//elem.setAttribute("src",session.sourceNode.src);
 			//var elem=(session.sourceNode).cloneNode(true);			
 			
 			topBox.appendChild(elem);
 			//needed
 			elem.setAttribute("width",session.sourceNode.width);
 			elem.setAttribute("height",session.sourceNode.height);
 			//fixes relative urls
 			elem.setAttribute("src",session.sourceNode.src);
 			//delete on doubleclick
 			//elem.setAttribute("ondblclick","imgDNDObserver.deleteThis(event)"); //whoa, but a gotcha! :-) 			
 			
 		 }catch(ex) {alert("Error: " + ex.message); /* or Die silently? */ }
 		},
 		
 		
 		
 		
 		//remove an image on a specific event
 		deleteThis: function (ev)
 		{  		  
 		   var img=ev.target;
 		   var tID=" "+img.getAttribute("id");
 		   if ((tID.search(/imgboard/) != -1 )) return;
 		   //else
 		   var board=img.parentNode;
 		   board.removeChild(img);
 		   ev.preventDefault();
 		},
 	
 };
