/*---------------------------------------*\
A Plugin for Xinha to create and modify  box elements
Developed for the wySUwyg extension for Firefox ( http://wysuwyg.mozdev.org )
 -----------------------------------------
 author: Rahul Singh
 e-mail: induscrypt@gmail.com
 
 Based on  Quick Tag Editor Plugin for HTMLArea-3.0
 by Cau guanabara 
\*---------------------------------------*/

function IndusPre(editor) {
  var cfg = editor.config;
  var self = this;

  cfg.registerButton({
	id       : "induspre",
	tooltip  :  this._lc("Box selected text"),
	image    : editor.imgURL("induspre.gif", "IndusPre"), 
	textMode : false,
  	action   : function(editor) { 
               self.buttonPress(editor); 
             }
  });
  cfg.addToolbarElement("induspre", "htmlmode", 1);  
}

IndusPre.prototype.buttonPress = function(editor) { 
	var self = this;
	var sel = editor.getSelectedHTML(); //if nothing, we'll add dummy
	var param = new Object();
	var prenode= null;
	param.editor = editor;	
	
	//search for the first block level ancestor
	var ancs=editor.getAllAncestors();
		
	for (i=0; i<ancs.length;i++)
	{
		var tag=ancs[i].tagName;
		var tmp=tag.match(/(^pre$)|(^div$)|(^b$)|(^center$)/i);
		if (tmp !=null){prenode=ancs[i]; break;}	
	}
	
	if (prenode)
		{		
		var c=confirm('Remove '+ prenode.tagName +' box?');
		if(c) {self.unsetPreTag(editor, param,prenode );return; }
		//else create nested inside
		
		c = confirm('Modify existing '+ prenode.tagName +' box ?');
		if(c) 
			{	
			   var prm= self.preloadParams(editor, prenode, sel); 			   
			   self.setPreTag(editor, prm , sel,prenode); 		
				return;		
			}
		
		
		c = confirm('Create another box\n inside this one?');
		if(c) {self.setPreTag(editor, null, sel,null ); return; }
		
		 else return;
 		}

	//Else create box
 	self.setPreTag(editor, null , sel);   
};


// workhorse functions start 

//Create or modify a box
//pops up the dialogs, gets the returned values, applies changes 
//args: editor, (needless)params,slection,node to change if modifying pre-existing
IndusPre.prototype.setPreTag = function(editor, param,sel,cnode) 
{

//popup 
	editor._popupDialog ( "plugin://IndusPre/indus-pre", 
		function( obj ) 
		{//on return, do this
    		if ( !obj ) 
    		{//user must have pressed Cancel
     		 return false;
     		}
     		 //else, OK has returned an obj with "temp1"
     		 var res=obj["templ"];
     		 //extract the element from the tag
     		 var tg= res.match(/^<[a-z]*/i);
     		 
     		 //if modifying an existing box
     		 if (cnode != null)
     		 {
     		  	editor.selectNodeContents(cnode);				
				var shtml=editor.getSelectedHTML();
				HTMLArea.removeFromParent(cnode);
				editor.insertHTML( res + shtml + "</"+(tg[0]).substring(1)+" >" );			 		 
     		 }
     		 
     		 else
     		 {     		 
     		 	//if nothing is selected, create block with some dummy text     		 
     		 	if (  (sel!=null) && (sel.search(/[^\s\r\n]/g)==-1)  )
     		 	editor.insertHTML( res + "This text is boxed " + "</"+(tg[0]).substring(1)+" >" );
     		 	else //surround selected text
     		 	editor.surroundHTML(res,"</"+(tg[0]).substring(1)+" >");
			}//else	
		}, param );
  
//editor.surroundHTML('<pre style="margin: 5px 5px 2px; width: 200px; background-color: rgb(99, 99, 99); float: left;">','</pre>');

};

//If you're already inside a box, remove it


IndusPre.prototype.unsetPreTag = function(editor, param, cnode) {

	//now, as this is nodeType==1, or an element, do 
	//what you can do with an elemnt
	
	editor.selectNodeContents(cnode);
	var t= confirm("Keep Boxed Content?\n Cancel to delete!");
	var shtml=editor.getSelectedHTML();
	HTMLArea.removeFromParent(cnode);
	
		
	if (t) editor.insertHTML(shtml) ;

};



//Loading Params for an existing box
IndusPre.prototype.preloadParams = function(editor, prenode ,sel) 
{

if ( prenode==null ) return null;
 var p=prenode;
 var s=p.style; //dprev.style.border
 outparam = {
    f_type    : (p.tagName).toLowerCase(),
    f_width   : s.width,
    f_height  : s.height,
    f_align   : (s.cssFloat).toLowerCase() ,
    f_bgcol   : s.backgroundColor,    
    f_border  : (s.borderTopStyle).toLowerCase(),
    f_bordercol  : s.borderTopColor,
    f_borderwidth  : s.borderTopWidth,
    f_radTL : s.MozBorderRadiusTopleft,
    f_radTR : s.MozBorderRadiusTopright,
    f_radBL : s.MozBorderRadiusBottomleft,
    f_radBR : s.MozBorderRadiusBottomright,
	f_opacity : s.MozOpacity,
	f_display : s.display,
	f_fgcol : s.color,
	f_txtalign : s.textAlign,	
	f_bgimgurl : s.backgroundImage,
	f_bgimgattach : s.backgroundAttachment,
	f_bgimgrept : s.backgroundRepeat
	
  };

 
 return outparam;

};

	

IndusPre._pluginInfo = {
name          : "IndusPre",
version       : "0.9 - beta",
developer     : "Rahul Singh",
developer_url : "mailto:induscrypt@gmail.com",
c_owner       : "Rahul Singh",
sponsor       : "Independent production",
sponsor_url   : "http://induscrypt.stumbleupon.com",
license       : "htmlArea"
};

IndusPre.prototype._lc = function(string) {
	
	
    return HTMLArea._lc(string, 'IndusPre');
   
   
   };
   
   
//function that gets the values and creates the tag  
//called by the popup html page, creates its return value (params)

function extractValues()
{
	var f=document.form1 ;
	var boxtype= f.lBoxType.options[f.lBoxType.selectedIndex].value ;
	
	var aligntype= null;
	if (f.lAlign.selectedIndex > 0)
	aligntype= f.lAlign.options[f.lAlign.selectedIndex].value ;	
	
	var boxWidth=f.tWidth.value;
		boxWidth=trimString(boxWidth);	
	var boxHeight=f.tHeight.value;
		boxHeight=trimString(boxHeight);	
	var bgColor=f.tBgCol.value;
		bgColor=trimString(bgColor);
		
	

	var displ = null;
	var opac = null;
	
	if (f.lDisplay.selectedIndex > 0)
		 {displ=f.lDisplay.options[f.lDisplay.selectedIndex].value ; }
	if (f.lOpacity.selectedIndex > 0)
		 {opac=f.lOpacity.options[f.lOpacity.selectedIndex].value ; }

	
	var bgimgsrc=null;
	var bgimgattchmnt="";
	var bgimgrpt="";
	
	itemp = f.tBgImg.value;
	itmp=trimString(itemp);
	
	if ( itemp.search(/^http[s]?:\/\/[^\n]*\.(jpg$|bmp$|gif$|png$)/i) >-1)
	{
		bgimgsrc=itemp;
		if (f.lBgImgAttach.selectedIndex > 0)
		 { bgimgattchmnt=f.lBgImgAttach.options[f.lBgImgAttach.selectedIndex].value ; }
		if (f.lBgImgRepeat.selectedIndex > 0)
		 { bgimgrpt=f.lBgImgRepeat.options[f.lBgImgRepeat.selectedIndex].value ; } 		
	}
	
	var boxfont=null;
	var boxfgcol=null;
	var boxtxtalign=null;
	
	boxfgcol=f.tTCol.value;
	 	boxfgcol=trimString(boxfgcol);
		
	if (f.lTAlign.selectedIndex > 0)
		 { boxtxtalign=f.lTAlign.options[f.lTAlign.selectedIndex].value ; }
	
	
	
	var borderstyle= null ;	
	var borderwidth= null;
	var borderColor=null;	
	var borderBevel=false;
	var borderBevelArray=[false,false,false,false];
	var borderBevelRadius="15px";
	
	if (f.lBorderStyle.selectedIndex > 0)
	{
	 borderstyle= f.lBorderStyle.options[f.lBorderStyle.selectedIndex].value ;	
	 borderwidth=f.lBorderWidth.options[f.lBorderWidth.selectedIndex].value ;	
	 	borderwidth=trimString(borderwidth);
	 borderColor=f.tBorderCol.value;
	 	borderColor=trimString(borderColor);
	 borderBevel=f.cBordBvl.checked;
	 
		if (borderBevel && (borderBevelArray!=null) )
	 	{
	 		var c=f.cBvl;
	 		borderBevelArray=[ c[0].checked,c[1].checked,c[2].checked,c[3].checked ];
	 		borderBevelRadius=f.lBorderRadius.options[f.lBorderRadius.selectedIndex].value ;
	 	}
	}
   
   //var boxtag= parseValues( boxtype, aligntype,  boxWidth, boxHeight, bgColor, borderstyle, borderwidth,borderColor,borderBevel,borderBevelArray,borderBevelRadius );
   var boxtag= parseValues( boxtype, aligntype,  boxWidth,  boxHeight, bgColor, bgimgsrc, bgimgattchmnt, bgimgrpt, boxfgcol, boxtxtalign, borderstyle, borderwidth,borderColor,borderBevel,borderBevelArray,borderBevelRadius,displ,opac );
	//alert(boxtag);
   return boxtag;
}	


//validate and parse, return a valid tag
//called by extractValues

function parseValues(btype, aligntype ,boxwidth, boxheight,bgcol, bgimgurl,  bgimgattach, bgimgrepeat, fgcol, txtalign, brdrstyle, brdrwidth, brdrcol,bordbvl,bvlarray,bvlrad,bdisplay,bopacity  )
{
	
    
	var strTag= '<' +btype + ' style=" ';
	if (aligntype !=null)
		strTag+='float:'+aligntype+ '; ';
		
	if ( (boxwidth.length>0) && (boxwidth.search(/[^\d]/) == -1) )
		strTag+='width:' + boxwidth + '; ';
	
	if ( (boxheight.length>0) && (boxheight.search(/[^\d]/) == -1) )
		strTag+='height:'+boxheight+ '; ';
	
	if ( checkColor(bgcol) ||(bgimgurl !=null ) )
	  { 
	    strTag+='background: ' ;
		
		if ( checkColor(bgcol) )   
				strTag+= ' ' + bgcol+ ' ';		
		if (bgimgurl !=null )
			{
				strTag+=" url("+ bgimgurl +") " ; //htmlarea.js will later add 's at the ends for SU compatibility		
				strTag+= ' scroll ' ; //default is ' '	Note: Removed, as SU hates it!	    bgimgattach
				strTag+= ' '+ bgimgrepeat + ' ' ; //default is ' '			
				strTag+= 'top left' ; //the image postion has to be there as otherwise FF forces it to 50% 
			}
	   strTag+= ';' ; 
	  }
	  
	 if (fgcol !=null)
		{ if ( (fgcol.length > 0) && checkColor(fgcol) )   
				strTag+= 'color: ' + fgcol+ '; ';
		}
	if (txtalign !=null)
		{ strTag+= 'text-align: ' + txtalign + ' ;';}
	
	if (brdrstyle != null )
		{		
			strTag+='border: ' ;	
			 
				strTag+=brdrwidth + ' ';
			if ( (brdrcol.length > 0) && checkColor(brdrcol)  ) 
				strTag+=brdrcol + ' ';		
		
			strTag+=brdrstyle + ' ; ';
			
			if (bordbvl)
				{	
					var tleft=''; tright='';bleft='';bright='';
					if(bvlarray[0]) tleft= "-moz-border-radius-topleft:"+ bvlrad +"; " ;
					if(bvlarray[1]) tright= "-moz-border-radius-topright:"+ bvlrad +"; " ;
					if(bvlarray[2]) bleft= "-moz-border-radius-bottomleft:"+ bvlrad +"; " ;
					if(bvlarray[3]) bright= "-moz-border-radius-bottomright:"+ bvlrad +"; " ;
				
					strTag+= tleft + tright + bleft + bright + ' padding-left: '+bvlrad+'; padding-right:'+bvlrad+'; padding-top: 5px; padding-bottom: 5px;';
				}
	
		}
	if (bopacity !=null)
	       {strTag+= 'opacity: '+ bopacity +'; '; }
	if (bdisplay!=null)
	       {strTag+= 'display: ' + bdisplay+'; ';}
	
	//close tag, add some addiotional info
	//note- if all margins are equal, FF will collapse them to one
	if (btype=='b') strTag += 'font-weight:normal; ' ;
	strTag += ' margin-top: 3px; margin-right:5px; margin-bottom: 3px; margin-left: 6px; " >'
	return strTag;	
	
}


//emulate  java's 'trim'

function trimString(str) { 
    str=str.replace(/^\s*/, '');
    str=str.replace(/\s*$/, '');
   	return str;
} 

//color -rgb and html - validity, checks for accidental deletions at least
function checkColor(colorstring)
{	if (colorstring.length ==0) return false;
    var rgbcheck = /^rgb\(\s*\d{1,3}\s*,\s*\d{1,3}\s*,\s*\d{1,3}\s*\)/i  ; 
    var htmlcheck= /^#[a-f0-9]{6}/i ;    
    return ( (colorstring.search(htmlcheck) > -1) || ( colorstring.search(rgbcheck) > -1) ) 

}
